unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, GLU, GL;

type
  TForm1 = class(TForm)
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    DC:HDC;
    hrc:HGLRC;
    procedure PixelFormat;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormPaint(Sender: TObject);
var
 ps:TPaintStruct;
begin
 BeginPaint(Handle,ps);
 glClearColor(1,0.5,0.5,1);
 glClear(GL_COLOR_BUFFER_BIT);

 glLineWidth(5);

 glBegin(GL_LINES);
  glColor3f (0.0, 1.0, 0.0);
  glVertex3f(-2.7,1.7,0);
  glVertex3f(-2.7,1,0);
  glColor3f (0.0, 0.0, 1.0);
  glVertex3f(-2.3,1.7,0);
  glVertex3f(-2.3,1,0);
 glEnd;

 glBegin(GL_LINE_STRIP);
  glColor3f (0.0, 1.0, 0.0);
  glVertex3f(-1,1.7,0);
  glVertex3f(-1,1,0);
  glColor3f (0.0, 0.0, 1.0);
  glVertex3f(-0.5,1.7,0);
  glVertex3f(-0.5,1,0);
 glEnd;

 glBegin(GL_LINE_LOOP);
  glColor3f (0.0, 1.0, 0.0);
  glVertex3f(0.5,1.7,0);
  glVertex3f(0.5,1,0);
  glColor3f (0.0, 0.0, 1.0);
  glVertex3f(1,1.7,0);
  glVertex3f(1,1,0);
 glEnd;

// 
 glBegin(GL_TRIANGLES);
  glColor3f (0.0, 1.0, 0.0);
  glVertex3f(-2.7,0.7,0);
  glVertex3f(-2.7,0.0,0);
  glVertex3f(-2.5,0.4,0);
  glColor3f (0.0, 0.0, 1.0);
  glVertex3f(-2.3,0.7,0);
  glVertex3f(-2.3,0.0,0);
  glVertex3f(-2.1,0.4,0);
 glEnd;

 glBegin(GL_TRIANGLE_STRIP);
  glColor3f (0.0, 1.0, 0.0);
  glVertex3f(-0.7,0.7,0);
  glVertex3f(-0.7,0.0,0);
  glVertex3f(-0.5,0.4,0);
  glColor3f (0.0, 0.0, 1.0);
  glVertex3f(-0.3,0.7,0);
  glVertex3f(-0.3,0.0,0);
  glVertex3f(-0.1,0.4,0);
 glEnd;

 glBegin(GL_TRIANGLE_FAN);
  glColor3f (0.0, 1.0, 0.0);
  glVertex3f(1.3,0.7,0);
  glVertex3f(1.3,0.0,0);
  glVertex3f(1.5,0.4,0);
  glColor3f (0.0, 0.0, 1.0);
  glVertex3f(1.7,0.7,0);
  glVertex3f(1.7,0.0,0);
  glVertex3f(1.9,0.4,0);
 glEnd;

//////// 
 glBegin(GL_QUADS);
  glColor3f (0.0, 1.0, 0.0);
  glVertex3f(-2.7,-1.7,0);
  glVertex3f(-2.7,-1.0,0);
  glVertex3f(-2.4,-1.0,0);
  glVertex3f(-2.4,-1.7,0);
  glColor3f (0.0, 0.0, 1.0);
  glVertex3f(-2.3,-1.7,0);
  glVertex3f(-2.3,-1.0,0);
  glVertex3f(-2.0,-1.0,0);
  glVertex3f(-2.0,-1.7,0);
 glEnd;

 glBegin(GL_QUAD_STRIP);
  glColor3f (0.0, 1.0, 0.0);
  glVertex3f(-0.7,-1.7,0);
  glVertex3f(-0.7,-1.0,0);
  glVertex3f(-0.5,-1.0,0);
  glVertex3f(-0.5,-1.7,0);
  glColor3f (0.0, 0.0, 1.0);
  glVertex3f(-0.3,-1.7,0);
  glVertex3f(-0.3,-1.0,0);
  glVertex3f(-0.1,-1.0,0);
  glVertex3f(-0.1,-1.7,0);
 glEnd;

 glBegin(GL_POLYGON);
  glColor3f (0.0, 1.0, 0.0);
  glVertex3f(1.3,-1.7,0);
  glVertex3f(1.3,-1.0,0);
  glVertex3f(1.1,-1.4,0);
  glColor3f (0.0, 0.0, 1.0);
  glVertex3f(1.7,-1.0,0);
  glVertex3f(1.7,-1.7,0);
  glVertex3f(1.9,-1.4,0);
 glEnd;

 glFlush();
 swapBuffers(dc);
 EndPaint(Handle,ps);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity( );

 if width <= height then
  glOrtho (-2, 2, -2*height/width, 2*height/width, -10.0, 10.0)
 else
  glOrtho (-2*width/height, 2*width/height, -2, 2, -10.0, 10.0);

 glViewport(0, 0, width, height);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 wglMakeCurrent(0,0);
 wglDeleteContext(hrc);
 ReleaseDC(handle,DC);
end;

procedure TForm1.PixelFormat;
var
 nPixelFormat:Integer;
 pfd:TPixelFormatDescriptor;
begin
 FillChar(pfd,Sizeof(pfd),0);

 pfd.nSize:=sizeof(pfd);
 pfd.nVersion:=1;
 pfd.dwFlags:=PFD_DOUBLEBUFFER+PFD_SUPPORT_OPENGL+PFD_DRAW_TO_WINDOW;
 pfd.iPixelType:=PFD_TYPE_RGBA;
 pfd.cColorBits:=24;
 pfd.cAlphaBits:=64;
 pfd.cAccumBits:=64;
 pfd.cDepthBits:=32;
 pfd.cStencilBits:=64;
 pfd.iLayerType:=PFD_MAIN_PLANE;

 nPixelFormat:=ChoosePixelFormat(DC,@pfd);
 if nPixelFormat<>0 then
  SetPixelFormat(DC,nPixelFormat,@pfd);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 DC:=GetDC(Handle);
 PixelFormat;
 hrc:=wglCreateContext(DC);
 wglMakeCurrent(DC,hrc);
end;

end.


